# IMGUI_Notes

Just a place I'm sharing all the notes and research I have on immediate mode user interfaces

# General

## Sean Barret

The Inner Product column on Immediate Mode GUIs:  
[Game Developer - September 2005 (Page 34-36)](assets/GDM_September_2005.pdf)  
[Sample Implementation](https://silverspaceship.com/inner/imgui/)  

## Casey Muratori

[Immediate-Mode Graphical User Interfaces - 2005](https://www.youtube.com/watch?v=Z1qyvQsjK5Y)  
[Original Molly Rocket IMGUI forum](https://web.archive.org/web/20140110175254/https://mollyrocket.com/forums/viewforum.php?f=10)  

## Jonathan Blow

[Improving Our Immediate-Mode UI Stuff (Part 1)](https://youtu.be/gPKDnu5QaZk)  
[Improving Our Immediate-Mode UI Stuff (Part 2)](https://www.youtube.com/watch?v=upURrmzpD5Q)  

## Ryan Fleury

[UI Series -- Table of Contents](https://www.rfleury.com/p/ui-series-table-of-contents)  

## Handmade

[January Meetup - Writing an IMGUI](https://youtu.be/wsJ8Y1HO250)  

## Tscoding's Related Content:

[Immediate UI for My Game in C++](https://youtu.be/8e56I1z9cn4)  
[Improving Immediate UI for My Game](https://youtu.be/-FYKw5rH2aU)  
[Making Reactive GUI From Scratch with Just Rectangles](https://youtu.be/-e_yyggsh_o)  
[OpenGL Text Rendering for My Immediate UI Library — Offline Stream #02](https://youtu.be/mq3UXqPmBE8)  
[We Need to Bring GUI Libraries Back! — Offline Stream #09](https://youtu.be/wWnjffo6gHc)  
[When UI Library is Bad — Offline Stream #13](https://youtu.be/yUGvLUPtgXY)  
[imhui](https://github.com/tsoding/imhui)  

## Other

[Johno's Imgui Article](https://www.johno.se/book/imgui.html)  
[Imgui PPT](https://www.cse.chalmers.se/edu/year/2011/course/TDA361/Advanced%20Computer%20Graphics/IMGUI.pdf)  
[Jari Komppa's Article](https://solhsa.com/imgui/)  
[Zero Memory Widget](https://perso.univ-lyon1.fr/thierry.excoffier/ZMW/)  
[Kiss SDL](https://github.com/actsl/kiss_sdl)  

# Relevant Libraries:

[layout](https://github.com/randrew/layout)  
C: [Nuklear](https://github.com/Immediate-Mode-UI/Nuklear)  
C++: [Dear Imgui](https://github.com/ocornut/imgui)  
Odin's MicroUI: [MicroUI](https://github.com/odin-lang/Odin/tree/master/vendor/microui)  
